package com.example.depanntout

import android.content.Intent
import android.os.Bundle
import android.widget.Button
import androidx.activity.enableEdgeToEdge
import androidx.appcompat.app.AppCompatActivity
import androidx.core.view.ViewCompat
import androidx.core.view.WindowInsetsCompat
import com.android.volley.toolbox.JsonObjectRequest
import com.android.volley.toolbox.Volley
import org.json.JSONObject

class Home : AppCompatActivity() {
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        enableEdgeToEdge()
        setContentView(R.layout.activity_home)
        ViewCompat.setOnApplyWindowInsetsListener(findViewById(R.id.home)) { v, insets ->
            val systemBars = insets.getInsets(WindowInsetsCompat.Type.systemBars())
            v.setPadding(systemBars.left, systemBars.top, systemBars.right, systemBars.bottom)
            insets
        }

        val buttonToClients = findViewById<Button>(R.id.btnClients)
        buttonToClients.setOnClickListener() {
            val intent = Intent(this, ListeClients::class.java)
            startActivity(intent)
        }

        val buttonToInterventions = findViewById<Button>(R.id.btnInterventions)
        buttonToInterventions.setOnClickListener() {
            val intent = Intent(this, ListeInterventions::class.java)
            startActivity(intent)
        }

        val buttonImport = findViewById<Button>(R.id.btnImport)
        buttonImport.setOnClickListener() {
            val queue = Volley.newRequestQueue(this)
            val url = "http://192.168.48.185:8000/intervention"
            val jsonObjectRequest = object : JsonObjectRequest(
                Method.POST, url, null,
                {  },
                {  }) {

                override fun getHeaders(): Map<String, String> {
                    val headers = HashMap<String, String>()
                    headers["Content-Type"] = "application/json"
                    return headers
                }

                override fun getBody(): ByteArray {
                    val jsonObject = JSONObject()
                    jsonObject.put("date", "2022-01-05")
                    jsonObject.put("observation", "Ceci est un test")
                    jsonObject.put("idClient", 1)
                    return jsonObject.toString().toByteArray()
                }
            }

            queue.add(jsonObjectRequest)
        }
    }
}