package com.example.depanntout

import android.content.Intent
import android.os.Bundle
import android.util.Log
import android.widget.Button
import androidx.activity.enableEdgeToEdge
import androidx.appcompat.app.AppCompatActivity
import androidx.core.view.ViewCompat
import androidx.core.view.WindowInsetsCompat
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.example.depanntout.bdd.ClientDAO
import com.example.depanntout.bdd.CreateBdDepannTout
import com.example.depanntout.bdd.DAO
import com.example.depanntout.bdd.Intervention
import com.example.depanntout.bdd.InterventionDAO

class ListeInterventions : AppCompatActivity() {
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        enableEdgeToEdge()
        setContentView(R.layout.activity_liste_interventions)
        ViewCompat.setOnApplyWindowInsetsListener(findViewById(R.id.main)) { v, insets ->
            val systemBars = insets.getInsets(WindowInsetsCompat.Type.systemBars())
            v.setPadding(systemBars.left, systemBars.top, systemBars.right, systemBars.bottom)
            insets
        }

        val buttonQuit = findViewById<Button>(R.id.btnQuit)
        buttonQuit.setOnClickListener() {
            finish()
        }

        val buttonAdd = findViewById<Button>(R.id.btnAdd)
        buttonAdd.setOnClickListener() {
            val intent = Intent(this, createIntervention::class.java)
            startActivity(intent)
        }

        val recyclerView = findViewById<RecyclerView>(R.id.recyclerView)
        recyclerView.layoutManager = LinearLayoutManager(this)

        val createBdDepannTout: CreateBdDepannTout = CreateBdDepannTout(this)
        val dao: DAO = DAO(this, createBdDepannTout)
        val interventionDAO : InterventionDAO = InterventionDAO(dao)
        var interventions: List<Intervention> = interventionDAO.getInterventions()

        val adapter = interventionAdapter(interventions, this)
        recyclerView.adapter = adapter

        val buttonImport = findViewById<Button>(R.id.btnImport)
        buttonImport.setOnClickListener() {
            Importation().importInterventionsFromServer(this) { interventionsServer ->
                if (interventionsServer.isNotEmpty()) {
                    for (intervention: Intervention in interventionsServer) {
                        interventionDAO.createIntervention(intervention)
                        Log.d("Intervention server importer :", intervention.idIntervention.toString())
                    }
                    interventions = interventions.plus(interventionsServer)
                }
                val adapter = interventionAdapter(interventions, this)
                recyclerView.adapter = adapter
            }
        }
    }
}