package com.example.depanntout.bdd

import android.content.Context
import android.database.sqlite.SQLiteDatabase
import android.database.sqlite.SQLiteOpenHelper
import android.provider.BaseColumns

class CreateBdDepannTout(context: Context) : SQLiteOpenHelper(context, "depannTout.db", null, 1) {
    override fun onCreate(db: SQLiteDatabase) {
        db.execSQL("CREATE TABLE 'clients' (idClient INTEGER PRIMARY KEY AUTOINCREMENT, firstname LONGTEXT, lastname LONGTEXT, tel LONGTEXT, mail LONGTEXT, adresse LONGTEXT)")
        db.execSQL("CREATE TABLE 'interventions' (idIntervention INTEGER PRIMARY KEY AUTOINCREMENT, datetime DATETIME, observation LONGTEXT, idClient INT REFERENCES clients(idClient))")
    }

    override fun onUpgrade(db: SQLiteDatabase, oldVersion: Int, newVersion: Int) {
        db.execSQL("DROP TABLE IF EXISTS 'clients'")
        db.execSQL("DROP TABLE IF EXISTS 'interventions'")
        onCreate(db)
    }

    override fun onDowngrade(db: SQLiteDatabase, oldVersion: Int, newVersion: Int) {
        onUpgrade(db, oldVersion, newVersion)
    }
}