package com.example.depanntout.bdd

import android.util.Log
import com.android.volley.toolbox.StringRequest
import com.android.volley.toolbox.Volley
import com.example.depanntout.Client

data class Intervention(
    val idIntervention: Int,
    val datetime: String,
    val observation: String,
    val idClient: Int
)

class InterventionDAO(private val dao: DAO) {
    fun createIntervention(intervention: Intervention) {
        dao.db.execSQL(
            "INSERT INTO interventions (datetime, observation, idClient) VALUES (?, ?, ?)",
            arrayOf(intervention.datetime, intervention.observation, intervention.idClient)
        )
    }

    fun deleteIntervention(intervention: Intervention) {
        dao.db.execSQL(
            "DELETE FROM interventions where idIntervention = ?",
            arrayOf(intervention.idIntervention)
        )
    }

    fun getInterventions(): List<Intervention> {
        val interventions: MutableList<Intervention> = arrayListOf<Intervention>()
        val cursor = dao.db.rawQuery("SELECT * FROM 'interventions'", null)
        if (cursor.moveToFirst()) {
            do {
                Log.d("DatabaseRow", "Column1: ${cursor.getString(0)}, Column2: ${cursor.getString(1)}")
                val idIntervention = cursor.getInt(cursor.getColumnIndexOrThrow("idIntervention"))
                val datetime = cursor.getString(cursor.getColumnIndexOrThrow("datetime"))
                val observation = cursor.getString(cursor.getColumnIndexOrThrow("observation"))
                val idClient = cursor.getInt(cursor.getColumnIndexOrThrow("idClient"))

                val client = Intervention(idIntervention, datetime, observation, idClient)
                interventions.add(client)
            } while (cursor.moveToNext())
        }
        cursor.close()
        return interventions
    }
}