package com.example.depanntout

import android.content.Intent
import android.os.Bundle
import android.widget.Button
import android.widget.EditText
import android.widget.Toast
import androidx.activity.enableEdgeToEdge
import androidx.appcompat.app.AppCompatActivity
import androidx.core.view.ViewCompat
import androidx.core.view.WindowInsetsCompat
import com.android.volley.toolbox.JsonObjectRequest
import com.android.volley.toolbox.StringRequest
import com.android.volley.toolbox.Volley
import com.example.depanntout.bdd.ClientDAO
import com.example.depanntout.bdd.CreateBdDepannTout
import com.example.depanntout.bdd.DAO
import com.example.depanntout.bdd.Intervention
import com.example.depanntout.bdd.InterventionDAO
import org.json.JSONObject
import java.lang.reflect.Method

class createIntervention: AppCompatActivity() {
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        enableEdgeToEdge()
        setContentView(R.layout.activity_create_intervention)
        ViewCompat.setOnApplyWindowInsetsListener(findViewById(R.id.main)) { v, insets ->
            val systemBars = insets.getInsets(WindowInsetsCompat.Type.systemBars())
            v.setPadding(systemBars.left, systemBars.top, systemBars.right, systemBars.bottom)
            insets
        }

        val buttonExit = findViewById<Button>(R.id.btnCancel)
        buttonExit.setOnClickListener() {
            finish()
        }

        val buttonCreate = findViewById<Button>(R.id.btnCreate)
        buttonCreate.setOnClickListener() {
            val observation = findViewById<EditText>(R.id.inputObserv).text.toString()
            val idClient = findViewById<EditText>(R.id.inputClient).text.toString().toInt()
            val date = findViewById<EditText>(R.id.inputDate).text.toString()
            val newIntervention: Intervention = Intervention(1, date, observation, idClient)
            val createBdDepannTout: CreateBdDepannTout = CreateBdDepannTout(this)
            val dao: DAO = DAO(this, createBdDepannTout)
            val interventionDAO : InterventionDAO = InterventionDAO(dao)
            interventionDAO.createIntervention(newIntervention)
            val intent = Intent(this, ListeInterventions::class.java)
            startActivity(intent)
            Toast.makeText(this, "Intervention ajouter", Toast.LENGTH_SHORT).show()
            finish()

            val queue = Volley.newRequestQueue(this)
            val url = "http://192.168.48.185:8000/intervention"
            val jsonObjectRequest = object : JsonObjectRequest(
                Method.POST, url, null,
                {  },
                {  }) {

                override fun getHeaders(): Map<String, String> {
                    val headers = HashMap<String, String>()
                    headers["Content-Type"] = "application/json"
                    return headers
                }

                override fun getBody(): ByteArray {
                    val jsonObject = JSONObject()
                    jsonObject.put("date", newIntervention.datetime)
                    jsonObject.put("observation", newIntervention.observation)
                    jsonObject.put("idClient", newIntervention.idClient)
                    return jsonObject.toString().toByteArray()
                }
            }

            queue.add(jsonObjectRequest)
        }
    }
}