package com.example.depanntout

import android.content.Context
import android.content.Intent
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.Button
import android.widget.TextView
import androidx.recyclerview.widget.RecyclerView
import com.example.depanntout.bdd.ClientDAO
import com.example.depanntout.bdd.CreateBdDepannTout
import com.example.depanntout.bdd.DAO
import com.example.depanntout.bdd.Intervention
import com.example.depanntout.bdd.InterventionDAO

class interventionAdapter(private val interventions: List<Intervention>, private val context: Context) : RecyclerView.Adapter<interventionAdapter.InterventionViewHolder>() {
    class InterventionViewHolder(itemView: View) : RecyclerView.ViewHolder(itemView) {
        val txtObserv: TextView = itemView.findViewById(R.id.txtObserv)
        val txtDate: TextView = itemView.findViewById(R.id.txtDate)
        val txtClient: TextView = itemView.findViewById(R.id.txtClient)
        var btnDel: Button = itemView.findViewById(R.id.btnDel)
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): InterventionViewHolder {
        val view = LayoutInflater.from(parent.context).inflate(R.layout.item_intervention, parent, false)
        return InterventionViewHolder(view)
    }

    override fun onBindViewHolder(holder: InterventionViewHolder, position: Int) {
        val intervention = interventions[position]

        holder.txtObserv.text = intervention.observation
        holder.txtDate.text = intervention.datetime
        holder.txtClient.text = intervention.idClient.toString()

        holder.btnDel.setOnClickListener {
            val createBdDepannTout: CreateBdDepannTout = CreateBdDepannTout(context)
            val dao: DAO = DAO(context, createBdDepannTout)
            val interventionDAO : InterventionDAO = InterventionDAO(dao)
            interventionDAO.deleteIntervention(intervention)
        }
    }

    override fun getItemCount(): Int = interventions.size
}